local beql = beql
local L = AceLibrary("AceLocale-2.2"):new("beql")

function beql:InitTooltip()
	self:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
	self:Hook("ContainerFrameItemButton_OnEnter","Hooks_ContainerFrameItemButton_OnEnter", true)
end

function beql:UPDATE_MOUSEOVER_UNIT()
	if beql.db.profile.tooltipmob then
		beql:ScanTooltip()
	end
end

function beql:Hooks_ContainerFrameItemButton_OnEnter()
	self.hooks.ContainerFrameItemButton_OnEnter()
	if beql.db.profile.tooltipitem then
		beql:ScanTooltip()
	end
end

function beql:ScanTooltip()
    if  GameTooltip ~= nil and getglobal('GameTooltipTextLeft1'):IsVisible() and getglobal('GameTooltipTextLeft1'):GetText() ~= nil  then
			return beql:ScanTooltipItem(getglobal('GameTooltipTextLeft1'):GetText())
    end	
	return false
end

function beql:ScanTooltipItem(queryString)
	if(queryString == nil) then return false end
	
	local oldSelection = GetQuestLogSelection()
	if oldSelection < 1 then oldSelection = 1 end
		
	local questID
	local numEntries = GetNumQuestLogEntries()
	local questTitle, level, questTag, isHeader
	local numObjectives, questObjectives, questDescription
	local found = false
	local text, typ, finished
	local x = nil
	
	-- loop through all quests
	for i=1, numEntries, 1 do
		questID = i
		questTitle, level, questTag, _, isHeader = GetQuestLogTitle(questID)
		x = nil
		
		if not isHeader then
			SelectQuestLogEntry(questID)
			if(questTitle) then				
				numObjectives = GetNumQuestLeaderBoards()
				if(numObjectives > 0) then	
					-- loop through all objectives
					for j=1, numObjectives, 1 do
						text, typ, finished = GetQuestLogLeaderBoard(j)
						if not text or strlen(text) == 0 then
							text = typ
						end
						
						x = string.find(text, queryString)
						
						if x ~= nil then
							found = true
						end
						
						if found then
							break
						end
					end -- loop through all objectives
				end	
									
				if  x ~= nil  then
					local completion = nil
					
					if  numObjectives > 0  then
						for y, z in string.gmatch(text, "(%d+)/(%d+)") do
							completion = "   ("..y.."/"..z..")"
						end
					end
						

					questTitle = beql:ColorText(questTitle,GetDifficultyColor(level).r,GetDifficultyColor(level).g,GetDifficultyColor(level).b)
					
					if completion ~= nil then
						questTitle = questTitle..completion
					end
					
					-- add tooltip line
					GameTooltip:AddLine(" ", 1, 1, 1, 1)
					GameTooltip:AddLine(questTitle, 1, 1, 1, 1)
					GameTooltip:SetHeight(GameTooltip:GetHeight() + 28)
					
					-- resize tooltip
					leng = getglobal(GameTooltip:GetName() .. "TextLeft" .. GameTooltip:NumLines()):GetStringWidth()
					leng = leng + 22
				
					if  leng > GameTooltip:GetWidth()  then
						GameTooltip:SetWidth(leng)
					end
				end
			end
		end
		
	end -- loop through all quests
	SelectQuestLogEntry(oldSelection)
end